#pragma once

#include <string>
#include <stdexcept>
#include "typedefs.h"

namespace affdex
{
    /*
        * Copyright (c) 2015 Affectiva, Inc. All rights reserved.
    */

    /// <summary>
    /// AffdexException.
    /// Base exception type for exceptions thrown by the Affectiva SDK.
    /// </summary>
    class AffdexException : public std::runtime_error
    {
    public:

        /// <summary>
        /// Retrieve the exception description.
        /// </summary>
        AFFDEXSDK std::string getExceptionMessage() const;

        /// <summary>
        /// Initializes a new instance of the <see cref="AffdexException"/> class.
        /// </summary>
        /// <param name="msg">The exception description.</param>
        AFFDEXSDK AffdexException(const std::string &msg);

    };

    /// <summary>
    /// AffdexLicenseException.
    /// Exceptions related to the SDK license.
    /// </summary>
    class AffdexLicenseException : public AffdexException
    {
    public:
        /// <summary>
        /// Initializes a new instance of the <see cref="AffdexLicenseException"/> class.
        /// </summary>
        /// <param name="msg">The exception description.</param>
        AFFDEXSDK AffdexLicenseException(const std::string &msg);
    };

}
